config/routes.rb
Rails.application.routes.draw do
  mount ActionCable.server => '/cable'
  get '/' => redirect('/positions')
  get '/healthz' => 'application#healthz'
  post '/client/index.php' => 'application#ulogger'
  resources :positions, only: [:index]
end

app/models/position.rb
class Position < ApplicationRecord
  belongs_to :track
  # after_create :broadcast

  def accelerations
    Acceleration.where(track: self.track, tracked_at: self.tracked_at)
  end

  private

  # def broadcast
  #   ActionCable.server.broadcast "position_#{track.user}",
  #                                latitude: latitude,
  #                                longitude: longitude
  # end
end

app/controllers/positions_controller.rb
class PositionsController < ApplicationController
  before_action :authenticate
  before_action :set_users, only: [:index]
  before_action :set_users_tracks, only: [:index]
  before_action :set_all_users, only: [:index]
  before_action :set_first_position, only: [:index]
  before_action :set_last_position, only: [:index]
  before_action :redirect_to_canoncial_url, only: [:index]
  before_action :set_since, only: [:index]
  before_action :set_until, only: [:index]
  before_action :set_positions, only: [:index]
  before_action :set_position, only: [:show, :edit, :update, :destroy]

  # GET /positions
  # GET /positions.json
  def index
    respond_to do |format|
      format.html {}
      format.json do
        render json: @positions.transform_keys { |user| user.name },
               except: [:created_at, :updated_at],
               include: { accelerations: { only: [:x, :y, :z, :tracked_at] } }
      end
      format.csv do
        require 'csv'
        filename = "positions-#{Time.now.strftime('%Y-%m-%d-%H-%M-%S')}.csv"
        response.headers['Content-Type'] = 'text/csv'
        response.headers['Content-Disposition'] = "attachment; filename=#{filename}"
        csv_string = CSV.generate do |csv|
          attributes = {
           user: %i[name],
           track: %i[id],
           position: %i[id altitude provider accuracy longitude latitude tracked_at speed battery_status battery_level bearing],
           acceleration: %i[x y z tracked_at]
          }
          csv << attributes.map do |model, attributes|
            attributes.map { |attribute| "#{model}_#{attribute}" }
          end.flatten
          select = attributes.map do |model, attributes|
            attributes.map do |attribute|
              "#{model}s.#{attribute} AS #{model}_#{attribute}"
            end.join(', ')
          end.join(', ')
          query = <<-SQL
            SELECT #{select}
            FROM accelerations
            FULL OUTER JOIN positions
            ON accelerations.track_id = positions.track_id
            INNER JOIN tracks
            ON accelerations.track_id = tracks.id
            INNER JOIN users
            ON tracks.user_id = users.id
            WHERE
              (
                ('#{@since.strftime('%Y-%m-%d %H:%M:%S')}' <= accelerations.tracked_at AND accelerations.tracked_at <= '#{@until.strftime('%Y-%m-%d %H:%M:%S')}') OR
                ('#{@since.strftime('%Y-%m-%d %H:%M:%S')}' <= positions.tracked_at AND positions.tracked_at <= '#{@until.strftime('%Y-%m-%d %H:%M:%S')}')
              ) AND accelerations.tracked_at = positions.tracked_at AND users.id in (#{params[:users].join(', ')})
          SQL
          ActiveRecord::Base.connection.execute(query).each do |row|
            csv << row.values
          end
        end
        render plain: csv_string
      end
    end
  end

  # GET /positions/1
  # GET /positions/1.json
  def show
  end

  # GET /positions/new
  def new
    @position = Position.new
  end

  # GET /positions/1/edit
  def edit
  end

  # POST /positions
  # POST /positions.json
  def create
    @position = Position.new(position_params)

    respond_to do |format|
      if @position.save
        format.html { redirect_to @position, notice: 'Position was successfully created.' }
        format.json { render :show, status: :created, location: @position }
      else
        format.html { render :new }
        format.json { render json: @position.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /positions/1
  # PATCH/PUT /positions/1.json
  def update
    respond_to do |format|
      if @position.update(position_params)
        format.html { redirect_to @position, notice: 'Position was successfully updated.' }
        format.json { render :show, status: :ok, location: @position }
      else
        format.html { render :edit }
        format.json { render json: @position.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /positions/1
  # DELETE /positions/1.json
  def destroy
    @position.destroy
    respond_to do |format|
      format.html { redirect_to positions_url, notice: 'Position was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_position
      @position = Position.find(params[:id])
    end

    def set_users
      # @users = User.all unless params[:users]&.any?
      # @users ||= User.where(id: params[:users])
      @users = [@user]
    end

    def set_users_tracks
      @users_tracks = @users.map(&:tracks).flatten
    end

    def set_all_users
      # @all_users = User.all
      @all_users = [@user]
    end

    def set_since
      @since = DateTime.parse(params[:since]) if params[:since]
      @since ||= @first_position.tracked_at
    end

    def set_until
      @until = DateTime.parse(params[:until]) if params[:until]
      @until ||= @last_position.tracked_at
    end

    def set_positions
      @positions = {}
      @users.each do |user|
        user_positions = Position.where(track: user.tracks)
                                 .where(tracked_at: @since..@until)
                                 .order(tracked_at: :asc)
        @positions[user] = user_positions if user_positions.any?
      end
    end

    def set_first_position
      @first_position = Position.where(track: @users_tracks)
                                .order(tracked_at: :asc)
                                .first
    end

    def set_last_position
      @last_position = Position.where(track: @users_tracks)
                               .order(tracked_at: :asc)
                               .last
    end

    def redirect_to_canoncial_url
      unless params[:since] && params[:until] && params[:users]
        params[:since] ||= 1.day.ago.at_beginning_of_day
        params[:until] ||= Time.now.at_end_of_day
        params[:users] ||= @all_users.map(&:id)
        redirect_to positions_path(since: params[:since], until: params[:until], users: params[:users])
      end
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def position_params
      params.require(:position).permit(:altitude, :provider, :accuracy, :longitude, :latitude, :tracked_at, :speed, :battery_status, :battery_level)
    end
end

app/helpers/positions_helper.rb
module PositionsHelper
end

app/views/positions/_form.html.erb
<%= form_with(model: position, local: true) do |form| %>
  <% if position.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(position.errors.count, "error") %> prohibited this position from being saved:</h2>

      <ul>
        <% position.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :altitude %>
    <%= form.text_field :altitude %>
  </div>

  <div class="field">
    <%= form.label :provider %>
    <%= form.text_field :provider %>
  </div>

  <div class="field">
    <%= form.label :accuracy %>
    <%= form.text_field :accuracy %>
  </div>

  <div class="field">
    <%= form.label :longitude %>
    <%= form.text_field :longitude %>
  </div>

  <div class="field">
    <%= form.label :latitude %>
    <%= form.text_field :latitude %>
  </div>

  <div class="field">
    <%= form.label :tracked_at %>
    <%= form.datetime_select :tracked_at %>
  </div>

  <div class="field">
    <%= form.label :speed %>
    <%= form.text_field :speed %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/positions/edit.html.erb
<h1>Editing Position</h1>

<%= render 'form', position: @position %>

<%= link_to 'Show', @position %> |
<%= link_to 'Back', positions_path %>

app/views/positions/index.slim
- content_for :title
  = 'Positions'

- if @positions.any?
  - @positions.each do |user, positions|
    ruby:
      last_position = positions.last
      positions = positions.map { |position| [position.latitude.to_f, position.longitude.to_f] }
    = map(center: { latlng: [last_position.latitude, last_position.longitude], zoom: 18 })
    javascript:
      var marker = L.marker([#{last_position.latitude}, #{last_position.longitude}]).addTo(map);
      var positions = #{positions.to_json.html_safe};
      var polyline = L.polyline(positions, { color: 'red', className: '#{user_color_class(user)}', opacity: 0.75, weight: 2 }).addTo(map);
      // map.fitBounds(polyline.getBounds());
      // positions.forEach(function (position) {
      //   L.circle(position, { radius: 0, color: 'red', weight: 3 }).addTo(map);
      // });
- else
  ruby:
  = map(center: { latlng: [52.518611111111, 13.408333333333] }, zoom: 13)

ruby:
  since = DateTime.parse(params[:since])
  untill = DateTime.parse(params[:until])
  range = untill - since

.date-slider-container
  #date-slider
javascript:
  function zeroPad(value, pad) {
    var padString = '';
    for (var i = 0; i < pad; i++) {
      padString += '0';
    }
    return (padString + value).slice(-1 * pad);
  }

  function formatDate(value) {
    date = new Date(value * 1000);
    year = date.getFullYear();
    month = zeroPad(date.getMonth() + 1, 2);
    day = zeroPad(date.getDate(), 2);
    hour = zeroPad(date.getHours(), 2);
    minute = zeroPad(date.getMinutes(), 2);
    return year + '-' + month + '-' + day + ' ' + hour + ':' + minute;
  }

  function urlParams() {
    var match,
        pl = /\+/g,
        search = /([^&=]+)=?([^&]*)/g,
        decode = function (s) { return decodeURIComponent(s.replace(pl, " ")); },
        query = window.location.search.substring(1),
        urlParams = {};
    while (match = search.exec(query)) {
      urlParams[decode(match[1])] = decode(match[2]);
    }
    return urlParams;
  }

  function paramString(params) {
    var paramString = '';
    Object.keys(params).forEach(function (key) {
      if (paramString == '') {
        paramString += '?'
      } else {
        paramString += '&'
      }
      paramString += key + '=' + encodeURIComponent(params[key]).replace('%20', '+');
    });
    return paramString;
  }

  var slider = document.getElementById('date-slider');
  noUiSlider.create(slider, {
    connect: true,
    range: {
      min: #{[(since - (0.2 * range)).to_i].min},
      max: #{[(untill + (0.2 * range)).to_i].max}
    },
    // Steps of 1 minute
    step: 1 * 60,
    // Two more timestamps indicate the handle starting positions.
    start: [#{since.to_i}, #{untill.to_i}],
    // No decimals
    format: {
      to: formatDate,
      from: Number
    }
  });
  slider.noUiSlider.on('change', function (range) {
    var params = urlParams();
    console.log(range);
    params.since = range[0] + ':00 UTC+0200';
    params.until = range[1] + ':00 UTC+0200';
    console.log('/positions' + paramString(params));
    Turbolinks.visit('/positions' + paramString(params));
    document.querySelectorAll('.noUi-handle').forEach(function (handle) {
      handle.classList.add('noUi-active');
    });
  });
  document.querySelectorAll('.noUi-handle').forEach(function (handle) {
    handle.classList.add('noUi-active');
  });

- if @users&.any?
  - content_for :additional_sidebar
    li
      .divider
    li
      a.subheader
        | Users
    - @all_users.each do |user|
      li.position-user
        label
          ruby:
            checked = {}
            checked = { checked: 'checked' } if @users.include?(user)
          input.filled-in data-user-id="#{user.id}" class="#{user_color_class(user)}" type='checkbox' *checked
          span
            = user.name
    li
      a href="#{positions_path(since: params[:since], until: params[:until], users: params[:users], format: :csv)}"
        i.material-icons.left cloud_download
        | CSV
    javascript:
      document.querySelectorAll('li.position-user input').forEach(function (checkbox) {
        checkbox.addEventListener('click', function () {
          if (this.checked) {
            var newUrl = window.location + '&users[]=' + this.dataset.userId;
          } else {
            var newUrl = decodeURIComponent(window.location + '').replace('&users[]=' + this.dataset.userId, '')
          }
          console.log(newUrl);
          Turbolinks.visit(newUrl);
        });
      });

app/views/positions/new.html.erb
<h1>New Position</h1>

<%= render 'form', position: @position %>

<%= link_to 'Back', positions_path %>

app/views/positions/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Altitude:</strong>
  <%= @position.altitude %>
</p>

<p>
  <strong>Provider:</strong>
  <%= @position.provider %>
</p>

<p>
  <strong>Accuracy:</strong>
  <%= @position.accuracy %>
</p>

<p>
  <strong>Longitude:</strong>
  <%= @position.longitude %>
</p>

<p>
  <strong>Latitude:</strong>
  <%= @position.latitude %>
</p>

<p>
  <strong>Tracked at:</strong>
  <%= @position.tracked_at %>
</p>

<p>
  <strong>Speed:</strong>
  <%= @position.speed %>
</p>

<%= link_to 'Edit', edit_position_path(@position) %> |
<%= link_to 'Back', positions_path %>